const pointerEvents = require('./pointerEvents/base');

pointerEvents.signals.on('new', function ({ pointerEvent, event }) {
  // do nothing if it's not a touch
  if (!/touch/i.test(event.type) && !/touch/.test(pointerEvent.pointerType)) {
    return;
  }

  // fake mouseenter/leave
  if (pointerEvent.type === 'down') {
    $(event.target).simulate('mouseover', pointerEvent);
    $(event.target).simulate('mousemove', pointerEvent);
  }

  event.preventDefault();

  // fake buttons
  pointerEvent.which = 1;
  event.button = 0;
  event.buttons = 1;
});

pointerEvents.signals.on('fired', function ({ pointerEvent }) {
  if (pointerEvent.type === 'up') {
    $(pointerEvent.target).simulate('mouseout', pointerEvent);
  }
});
